library(dplyr)

test_that("networkconnection", {

  source(system.file("extdata", "sample_flines.R", package = "nhdplusTools"))

  suppressWarnings(
  sample_flines <- nhdplusTools::prepare_nhdplus(sample_flines, 0, 0, 0, FALSE) %>%
    left_join(select(sample_flines, COMID, DnHydroseq, DnLevelPat, Pathlength,
                     TerminalPa, FCODE, TotDASqKM)) %>%
    sf::st_as_sf())

  sample_flines <- nhdplusTools::make_standalone(sample_flines)

  sample_flines$DnLevelPat[is.na(sample_flines$toCOMID)] <- NA
  sample_flines$DnHydroseq[is.na(sample_flines$toCOMID)] <- NA

  comid <- c(11689684, 11690056, 11688856, 11687550, 11691374, 11690260)

  out <- NetworkConnection(comid, sample_flines)

  testthat::expect_equal(length(out), 235)

  # sub <- sf::st_geometry(filter(sample_flines, COMID %in% out))
  #
  # plot(sf::st_geometry(sample_flines), col = "blue", lwd = 1)
  # plot(sf::st_geometry(filter(sample_flines, COMID %in% out)), col = "blue", lwd = 2, add = TRUE)
  #
})
#
# reprex::reprex({
#
#   library(nhdplusTools)
#   library(hyRefactor)
#   library(hyfabric)
#
#   source(system.file("extdata", "sample_flines.R", package = "nhdplusTools"))
#
#   sample_flines <- nhdplusTools::prepare_nhdplus(sample_flines, 0, 0, 0, FALSE) %>%
#     left_join(select(sample_flines, COMID, DnHydroseq, DnLevelPat, Pathlength,
#                      TerminalPa, FTYPE, TotDASqKM)) %>%
#     sf::st_as_sf()
#
#   sample_flines <- nhdplusTools::make_standalone(sample_flines)
#
#   sample_flines$DnLevelPat[is.na(sample_flines$toCOMID)] <- NA
#   sample_flines$DnHydroseq[is.na(sample_flines$toCOMID)] <- NA
#
#   comid <- c(11689684, 11690056, 11688856, 11687550, 11691374, 11690260)
#
#   out <- NetworkConnection(comid, sample_flines)
#
#   testthat::expect_equal(length(out), 128)
#
#   # Note there is some disconnected network.
#
#   #We can do this with hyRefactor...
#   outlets <- data.frame(ID = comid, type = c("outlet", "outlet", "outlet",
#                                              "outlet", "outlet", "terminal"))
#
#   sample_flines2 <- dplyr::select(sample_flines, ID = COMID, toID = toCOMID,
#                                   LevelPathID = LevelPathI, Hydroseq, TotDASqKM)
#
#   sample_flines2$toID[sample_flines2$toID == 0 |
#                         !sample_flines2$toID %in% sample_flines2$ID] <- NA
#
#   lps <- hyRefactor:::get_lps(sample_flines2)
#
#   out <- hyRefactor:::make_outlets_valid(outlets, sample_flines2, lps)
#
#   # Note that this has 20 rows (outlets) and we passed in 6 outlets.
#   # If we run NetworkConnection on this set we get a complete network (and then some)
#   out2 <- NetworkConnection(out$ID, sample_flines)
#
#   plot(sf::st_geometry(sample_flines), col = "blue", lwd = 1)
#   plot(sf::st_geometry(filter(sample_flines, COMID %in% out2)), col = "blue", lwd = 2, add = TRUE)
#
#   # only_larger limits some small tribs added at confluences.
#   out <- hyRefactor:::make_outlets_valid(outlets, sample_flines2, lps, only_larger = TRUE)
#
#   # there is a da_thresh to further limit outlets that get added.
#   # doesn't do anything here.
#   out <- hyRefactor:::make_outlets_valid(outlets, sample_flines2, lps,
#                                          da_thresh = 10, only_larger = TRUE)
#
#   out3 <- NetworkConnection(out$ID, sample_flines)
#
#   plot(sf::st_geometry(sample_flines), col = "blue", lwd = 1)
#   plot(sf::st_geometry(filter(sample_flines, COMID %in% out3)), col = "blue", lwd = 2, add = TRUE)
#
# })
